program xmouse;

uses Windows;

var
  timeout: Integer;
  tracking: Boolean;
  zorder: Boolean;

procedure CheckError(R: BOOL);
var
  buf: PChar;
begin
  if R then
    Exit;
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_ALLOCATE_BUFFER
      or FORMAT_MESSAGE_IGNORE_INSERTS or $FF, nil, GetLastError,
      (SUBLANG_DEFAULT shl 10) or LANG_NEUTRAL, PChar(@buf), 0, nil);
  MessageBox(GetDesktopWindow, buf, 'xmouse', MB_ICONERROR);
  LocalFree(HLOCAL(buf));
  Halt(1);
end;

procedure Usage;
  function BStr(Value: Boolean): string;
  begin
    if Value then
      Result := 'on'
    else
      Result := 'off';
  end;
  function IStr(Value: Integer): string;
  begin
    Str(Value, Result);
  end;
begin
  CheckError(
    SystemParametersInfo(SPI_GETACTIVEWINDOWTRACKING, 0, @tracking, 0));
  CheckError(SystemParametersInfo(SPI_GETACTIVEWNDTRKTIMEOUT, 0, @timeout, 0));
  CheckError(SystemParametersInfo(SPI_GETACTIVEWNDTRKZORDER, 0, @zorder, 0));
  MessageBox(GetDesktopWindow, PChar(
        'usage: xmouse [-z] delay'#13#10+
        #13#10+
        '  delay'#9'active window tracking delay (milliseconds)'#13#10+
                 #9'  -1: tracking off'#13#10+
        '  -z'#9'bring to top'#13#10+
        #13#10+
        #13#10+
        'current settings: '#13#10+
        #13#10+
        '  tracking'#9#9 + BStr(tracking) + #13#10 +
        '  delay'#9#9 + IStr(timeout) + ' msec.'#13#10 +
        '  bring to top'#9 + BStr(zorder)
      ), 'xmouse', 0);
  Halt(2);
end;

var
  code: Integer;
begin
  if ParamCount = 0 then
    Usage;

  if ParamStr(1) = '-z' then
  begin
    if ParamCount = 1 then
      Usage;
    zorder := True;
    Val(ParamStr(2), timeout, code);
  end else
    Val(ParamStr(1), timeout, code);

  tracking := timeout > -1;
  CheckError(SystemParametersInfo(SPI_SETACTIVEWINDOWTRACKING, 0,
      Pointer(tracking), 0));
  CheckError(SystemParametersInfo(SPI_SETACTIVEWNDTRKTIMEOUT, 0,
      Pointer(timeout), 0));
  CheckError(SystemParametersInfo(SPI_SETACTIVEWNDTRKZORDER, 0,
      Pointer(zorder), 0));
end.
